#ifndef toto_definition
#define toto_definition 1
#include "quickasn.h"
#include <map.h>

class Grammtoto : public GenGramm {
    
    public :
    
        typedef map<EString, int *, LessString>     TabObject ;
        
        Grammtoto ()
        {
            int *ptInt ;
        }
        
        ~Grammtoto ()
        {
            TabObject::iterator iter ;
            
            for ( iter = pvTabObject.begin() ; iter != pvTabObject.end() ; 
                    iter++ ) 
                free((*iter).second);
            pvTabObject.erase(pvTabObject.begin(), pvTabObject.end());
        }
        
        virtual int *GetObjectDef ( EString name )
        {
            TabObject::iterator iter ;
            
            iter = pvTabObject.find(name);
            if ( iter != pvTabObject.end() ) 
                return (*iter).second ;
            else 
                return (int *)0 ;
        }
        
        virtual PTREE   DecodeObjectIdentifier (PTREE objectList) ;
        virtual PTREE   Root (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    Root (EString &resString, PTREE val) ;
        virtual PTREE   __Rule0 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule0 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule1 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule1 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule2 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule2 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule3 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule3 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule4 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule4 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule5 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule5 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule6 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule6 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule7 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule7 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule8 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule8 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule9 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule9 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule10 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule10 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule11 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule11 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule12 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule12 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule13 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule13 (EString &resString, PTREE val) ;
        virtual PTREE   __Rule14 (EString &val, CoordString &coord
            , bool checkTag) ;
        virtual void    __Rule14 (EString &resString, PTREE val) ;
        
        virtual PTREE DecodeString ( EString &ruleName, EString &val
            , CoordString &coord, bool checkTag )
        {
            if ( ruleName == "" ) 
                return Root(val, coord, checkTag);
            if ( ruleName == "Root" ) 
                return Root(val, coord, checkTag);
            if ( ruleName == "__Rule0" ) 
                return __Rule0(val, coord, checkTag);
            if ( ruleName == "__Rule1" ) 
                return __Rule1(val, coord, checkTag);
            if ( ruleName == "__Rule2" ) 
                return __Rule2(val, coord, checkTag);
            if ( ruleName == "__Rule3" ) 
                return __Rule3(val, coord, checkTag);
            if ( ruleName == "__Rule4" ) 
                return __Rule4(val, coord, checkTag);
            if ( ruleName == "__Rule5" ) 
                return __Rule5(val, coord, checkTag);
            if ( ruleName == "__Rule6" ) 
                return __Rule6(val, coord, checkTag);
            if ( ruleName == "__Rule7" ) 
                return __Rule7(val, coord, checkTag);
            if ( ruleName == "__Rule8" ) 
                return __Rule8(val, coord, checkTag);
            if ( ruleName == "__Rule9" ) 
                return __Rule9(val, coord, checkTag);
            if ( ruleName == "__Rule10" ) 
                return __Rule10(val, coord, checkTag);
            if ( ruleName == "__Rule11" ) 
                return __Rule11(val, coord, checkTag);
            if ( ruleName == "__Rule12" ) 
                return __Rule12(val, coord, checkTag);
            if ( ruleName == "__Rule13" ) 
                return __Rule13(val, coord, checkTag);
            if ( ruleName == "__Rule14" ) 
                return __Rule14(val, coord, checkTag);
            return PTREE(0);
        }
        
        virtual void EncodeString ( EString &ruleName, EString &resString
            , PTREE val )
        {
            if ( ruleName == "" ) 
                Root(resString, val);
            if ( ruleName == "Root" ) {
                Root(resString, val);
                return ;
            }
            if ( ruleName == "__Rule0" ) {
                __Rule0(resString, val);
                return ;
            }
            if ( ruleName == "__Rule1" ) {
                __Rule1(resString, val);
                return ;
            }
            if ( ruleName == "__Rule2" ) {
                __Rule2(resString, val);
                return ;
            }
            if ( ruleName == "__Rule3" ) {
                __Rule3(resString, val);
                return ;
            }
            if ( ruleName == "__Rule4" ) {
                __Rule4(resString, val);
                return ;
            }
            if ( ruleName == "__Rule5" ) {
                __Rule5(resString, val);
                return ;
            }
            if ( ruleName == "__Rule6" ) {
                __Rule6(resString, val);
                return ;
            }
            if ( ruleName == "__Rule7" ) {
                __Rule7(resString, val);
                return ;
            }
            if ( ruleName == "__Rule8" ) {
                __Rule8(resString, val);
                return ;
            }
            if ( ruleName == "__Rule9" ) {
                __Rule9(resString, val);
                return ;
            }
            if ( ruleName == "__Rule10" ) {
                __Rule10(resString, val);
                return ;
            }
            if ( ruleName == "__Rule11" ) {
                __Rule11(resString, val);
                return ;
            }
            if ( ruleName == "__Rule12" ) {
                __Rule12(resString, val);
                return ;
            }
            if ( ruleName == "__Rule13" ) {
                __Rule13(resString, val);
                return ;
            }
            if ( ruleName == "__Rule14" ) {
                __Rule14(resString, val);
                return ;
            }
        }
    
    private :
    
        TabObject   pvTabObject ;
};
#endif
